<?php
defined('APP') or die('Hacking attemp!');
class Controller_Index extends Core_Controller{
	public function __construct(){
		parent::__construct();
		parent::loadModel('home');
		$this->view->strfoot = $this->model->cfsite['Copyright'];
		$this->view->sitename = $this->model->cfsite['SiteName'];
		$this->view->adminemail = $this->model->cfsite['AdminEmail'];
    	}
    public function indexAction(array $param){
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsearch'])){
			header('Location: '.BASE_URL.'?index&search&k='.urlencode(trim($_POST['keys'])));
			return;
			}
        $this->view->title_url = array('ptitle'=>$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		$this->view->listcate = $this->model->getAllCategories();
		$order = 'TotalSent';
		if(!isset($param['s']) || $param['s']==1)
			$order = 'TotalSent';
		elseif($param['s']==2)
			$order = 'TotalViews';
		elseif($param['s']==3)
			$order = 'TotalPoints/TotalRated';
		elseif($param['s']==4)
			$order = 'DateCreated';
		$this->view->psort = $param['s'];
		/***********begin paging****************/
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->model->cfsite['RecordsPerPage'];
		$config['js_numrows_page'] = count($this->model->getAllProducts($order,''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?index&index'.$strquery;
		$paging = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		/*************End paging**********************/
		$this->view->ttpage = $paging;
		$this->view->listpro = $this->model->getAllProducts($order, $limit);
        $this->view->render('_home');
    	}
	public function viewcardAction(array $param){
		if(!array_key_exists('id',$param) || $param['id']==0)
			die('Your bad URL !!');
		$result = $this->model->getDetailCard($param['id']);
		$this->view->listcate = $this->model->getAllCategories();
		if(count($result)>0){
			$this->view->carddetail = $result;
			$this->view->title_url = array('ptitle'=>$result[0]['CardName'].' - '.$this->model->cfsite['SiteName'], 'metadesc'=>$result[0]['ShortDesc'], 'metaimg'=>$result[0]['CardImg'],'metatitle'=>$result[0]['CardName']);
			$this->view->othercards = $this->model->getOtherCards($param['id'],$result[0]['CardCate']);
			$this->model->IncreaseView($param['id']);
			}
		else $this->view->title_url = array('There is no record - '.$this->model->cfsite['SiteName']);
		$this->view->render('viewcard');
		}
	public function likecardAction(array $param){
		$istime = strtotime ( '- 1 days' , strtotime (date('Y-m-d H:i:s')) ) ;
		if(!$this->model->CheckAction('IsLike',$this->IpAddress(),date('Y-m-d H:i', $istime),$param['id']))
			echo json_encode(array("jval"=>-1));
		elseif(!$this->model->IncreaseLike($param['id'],$this->IpAddress(),date('Y-m-d H:i:s', $istime)))
			echo json_encode(array("jval"=>-2));
		else echo json_encode(array("jval"=>1));
		}
	public function ratingcardAction(array $param){
		$istime = strtotime ( '- 1 days' , strtotime (date('Y-m-d H:i:s')) ) ;
		if(!$this->model->CheckAction('IsRating',$this->IpAddress(),date('Y-m-d H:i', $istime),$param['id']))
			echo json_encode(array("jval"=>-1));
		elseif(!$this->model->RatingCard($param['id'],$this->IpAddress(),date('Y-m-d H:i:s', $istime), $param['p']))
			echo json_encode(array("jval"=>-2));
		else echo json_encode(array("jval"=>1));
		}
	public function sendcardAction(array $param){
		if($this->model->cfsite['RequiredToLoginToSend'] == 1 && !isset($_SESSION['uid'])){
			header('Location: '.BASE_URL.'?member&signin');
			return;
			}
		if(!array_key_exists('id',$param) || $param['id']==0)
			die('Your bad URL !!');
		$result = $this->model->getDetailCard($param['id']);
		$this->view->listcate = $this->model->getAllCategories();
		if(count($result)>0){
			$this->view->carddetail = $result;
			$this->view->title_url = array('ptitle'=>'Send card - '.$result[0]['CardName'], 'metadesc'=>$result[0]['ShortDesc'], 'metaimg'=>$result[0]['CardImg'],'metatitle'=>$result[0]['CardName']);
			$this->view->fonts = $this->model->getAllFonts();
			$this->view->colors = $this->model->getAllColors();
			if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smsend'])){
				if(empty($_POST['sendername']) || trim($_POST['sendername'])=='')
					$this->view->err_sn = 'Please enter sender name';
				elseif(empty($_POST['senderemail']) || trim($_POST['senderemail'])=='')
					$this->view->err_se = 'Please enter sender email';
				elseif(!$this->valid_email(trim($_POST['senderemail'])))
					$this->view->err_se = 'Sender email invalid';
				elseif($_POST['addmess']=='on' && (empty($_POST['message']) || trim($_POST['message'])==''))
					$this->view->err_m = 'Please enter your message';
				elseif(empty($_POST['receivername']) || trim($_POST['receivername'])=='')
					$this->view->err_rn = 'Please enter receiver name';
				elseif(empty($_POST['receiveremail']) || trim($_POST['receiveremail'])=='')
					$this->view->err_re = 'Please enter receiver email';
				elseif(!$this->valid_email(trim($_POST['receiveremail'])))
					$this->view->err_re = 'Receiver email invalid';
				elseif(strtolower(trim($_POST['receiveremail']))==strtolower(trim($_POST['senderemail'])))
					$this->view->err_re = 'Receiver\'s email same with sender\'s email.';
				else{
					$_err = 0;
					$filename = NULL;
					if(!empty($_FILES['musicfile']['name'])){
						$extension = pathinfo($_FILES['musicfile']['name']);
						$extension = $extension['extension'];
						if($_FILES['musicfile']['size']/1024 > 50000){
							$this->view->err_f = 'Max file size is 5MB';
							$_err = 1;
							}
						elseif(!in_array(strtolower($extension), array('mp3'))){
							$this->view->err_f = 'File format is mp3';
							$_err = 1;
							}
						else{
							$temp = $this->random_string(16);
							$filename = $temp.'.'.$extension;
							if(!move_uploaded_file($_FILES['musicfile']['tmp_name'],dirname(dirname(__FILE__)).'/public/ecards/musics/'.$filename)){
								$this->view->err_f = 'An error while upload file';
								$_err = 1;
								}				
							}
						}
					if(intval($_err)==0){
						$istext = $_POST['addmess']=='on'?1:0;
						$strid = $this->random_string(32);
						$isview = $_POST['alert']=='on'?1:0;
						$isnew = $_POST['receiver']=='on'?1:0;
						$data = array('CardId' => $param['id'], 'SenderId' => 0, 'SenderName' => "'".addslashes(trim($_POST['sendername']))."'", 'SenderEmail' => "'".addslashes(trim($_POST['senderemail']))."'", 'RecipientId' => 0, 'RecipientName' => "'".addslashes(trim($_POST['receivername']))."'", 'RecipientEmail' => "'".addslashes(trim($_POST['receiveremail']))."'", 'IsText' => $istext, 'Message' => "'".addslashes(trim(htmlentities($_POST['message'])))."'", 'TopMessage' => intval($_POST['topmess']), 'LeftMessage' => intval($_POST['leftmess']), 'WidthMessage' => intval($_POST['widthmess']), 'HeightMessage' => intval($_POST['heightmess']), 'AttachFile' => "'".$filename."'", 'MessageFont' => "'".addslashes(trim($_POST['messfont']))."'", 'MessageColor' => "'".addslashes(trim($_POST['messcolor']))."'", 'IsRead' => 0, 'SentDate' => "'".date('Y-m-d H:i:s')."'", 'ReadDate' => 'NULL', 'IpAddress' => "'".$this->IpAddress()."'", 'StringId' => "'".$strid."'", 'IsNoticeViewed' => $isview, 'IsNoticeNewCard' => $isnew);
						$resul = $this->model->SendCard($data);
						if($resul==0)
							$this->view->error = 'An error occurred, please try again';
						else{
							$this->model->UpdCardPopular($param['id']);
							$mess = 'Dear, '.$_POST['receiveremail'].' !!<br><br>'.$_POST['sendername'].' <i>('.$_POST['senderemail'].')</i> sent to you <b>a '.$result[0]['CardName'].'</b> ecard from '.$this->model->cfsite['SiteName'].'<br><br><a href="'.BASE_URL.'?category&viewmycard&id='.$strid.'">Click here</a> to view ecard.';
							@mail(trim($_POST['receiveremail']), '=?UTF-8?B?'.base64_encode('Send ecard from '.$this->model->cfsite['SiteName']).'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".$this->model->cfsite['AdminEmail']);
							$this->view->succ = 'Thank you for sending an ecard!';
							}
						}
					}
				}
			}
		else $this->view->title_url = array('There is no record - '.$this->model->cfsite['SiteName']);
		$this->view->render('sendcard');
		}
	public function pagesAction(array $param){
		if(!array_key_exists('id',$param) || $param['id']==0)
			die('Your bad URL !!');
		$result = $this->model->getDetailPage($param['id']);
		$this->view->listcate = $this->model->getAllCategories();
		if(count($result)>0){
			$this->view->pagedetail = $result;
			$this->view->title_url = array('ptitle'=>$result[0]['PageName'].' - '.$this->model->cfsite['SiteName'], 'metadesc'=>$result[0]['PageName'].' - '.$this->model->cfsite['SiteName'], 'metaimg'=>'','metatitle'=>$result[0]['PageName'].' - '.$this->model->cfsite['SiteName']);
			}
		else $this->view->title_url = array('There is no record - '.$this->model->cfsite['SiteName']);
		$this->view->render('pages');
		}
	public function searchAction(array $param){
		if(!array_key_exists('k',$param) || empty($param['k'])){
			header('Location: '.BASE_URL);
			return;
			}
        $this->view->title_url = array('ptitle'=>'Results serach - '.$this->model->cfsite['SiteName'],'plogo'=>$this->model->cfsite['LogoName']); 
		$this->view->listcate = $this->model->getAllCategories();
		/***********begin paging****************/
		$config['lastpage'] = $this->model->cfsite['LastPage'];
		$config['firstpage'] = $this->model->cfsite['FirstPage'];
		$config['showeachside'] = $this->model->cfsite['ShowEachSide'];
		$config['per_page'] = $this->model->cfsite['RecordsPerPage'];
		$config['js_numrows_page'] = count($this->model->SearchProducts(urldecode($param['k']),''));
		$config['curpage'] = array_key_exists('p',$param)?$param['p']:1;
		$config['rs_start'] = ($config['curpage']*$config['per_page'])-$config['per_page'];
		if($config['js_numrows_page'] < $config['per_page'])
			$config['per_page'] = $config['js_numrows_page'];
		if(array_key_exists('p',$param))
			unset($param['p']);
		$strquery = '';
		foreach($param as $kp =>$vp)
			$strquery .= '&'.$kp.'='.$vp;
		$config['cururl'] = BASE_URL.'?index&search'.$strquery;
		$paging = $this->Pagination($config);
		$limit = " limit ".$config['rs_start'].", ".$config['per_page'];
		/*************End paging**********************/
		$this->view->ttpage = $paging;
		$this->view->vkey = $param['k'];
		$this->view->listpro = $this->model->SearchProducts(urldecode($param['k']), $limit);
        $this->view->render('search');
    	}
	public function contactAction(){
		$this->view->mnsys =3;
		if($_SERVER['REQUEST_METHOD']=='POST' && isset($_POST['smcontact'])){
			if(empty($_POST['email']) || trim($_POST['email'])=='')
				$this->view->err_e = 'Please enter your email';
			elseif(!$this->valid_email(trim($_POST['email'])))
				$this->view->err_e = 'Your email invalid';
			elseif(empty($_POST['body']) || trim($_POST['body'])=='')
				$this->view->err_b = 'Please enter body of letter';
			elseif(!isset($_SESSION['uid']) && (empty($_POST['code']) || trim($_POST['code'])==''))
				$this->view->err_c = 'Please security code';
			elseif(!isset($_SESSION['uid']) && !empty($_POST['code']) && trim($_POST['code'])!=$_SESSION['encoded_captcha'])
				$this->view->err_c = 'Security code incorrect';
			else{
				$this->view->succ = 'Your ideas has sent us !<br>We will answer the earliest';
				$mess = 'Dear, admin !!<br><br>'.$_POST['body'].'<br><br>Please answer as soon as possible!';
				@mail(trim($this->model->cfsite['AdminEmail']), '=?UTF-8?B?'.base64_encode('Contact from '.$this->model->cfsite['SiteName']).'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".$_POST['email']);
				}
			}
		$this->view->listcate = $this->model->getAllCategories();
		$this->view->render('contact');
		}
	public function FbloginAction(){
		require_once 'lib/facebook/facebook.php';
		$facebook = new Facebook(array(
			'appId'		=>  '1416989418562577',
			'secret'	=> '23dac943a9633b0e98a5bf7b944b8307',
			));
		$user = $facebook->getUser();
		if($user){
			try{
				$user_profile = $facebook->api('/me');
				}
			catch(FacebookApiException $e){
				error_log($e);
				$user = NULL;
				}		
			}
		if(isset($user_profile)){
			$exits = $this->model->UserExits($user_profile['email']);
			if($exits[0]==-1){
				$_SESSION['error'] = 'An error occurred, please try again';
				header('Location: '.BASE_URL.'?member&signin');
				return;
				}
			elseif($exits[0]==-2){
				$_SESSION['error'] = 'Can not check banned for user';
				header('Location: '.BASE_URL.'?member&signin');
				return;
				}
			elseif($exits[0]==-3){
				$_SESSION['error'] = '<i>Your account has banned.<br>Reason: '.$exits[1].'<br>Banned date: '.$exits[2].'</i>';
				header('Location: '.BASE_URL.'?member&signin');
				return;
				}
			elseif($exits[0]>0){
				$_SESSION['uid'] = $exits[0];
				$_SESSION['umail'] = $user_profile['email'];
				$_SESSION['ugrou'] = 1;
				header('Location: '.BASE_URL.'?member&account');
				return;
				}
			elseif($exits[0]==0){
				$str = $this->random_string(6);
				$random = sha1($this->random_string(32).$user_profile['email'].$str);
				$isbirthday = date('Y-m-d', strtotime($user_profile['birthday']));
				$isgen = ($user_profile['gender']=='male')?1:2;
				$data = array('Email' => "'".addslashes(trim($user_profile['email']))."'", 'FullName' => "'".addslashes($user_profile['first_name'].' '.$user_profile['last_name'])."'", 'Birthday' => "'".$isbirthday."'", 'Password' => "'".md5($str.$str)."'", 'RandomStr' => "'".$str."'", 'StrActive' => "'".$random."'", 'IsActive' => 1, 'SignedDate' => "'".date('Y-m-d')."'", 'LastLogin' => "'".date('Y-m-d')."'", 'IpAddress' => "'".$this->IpAddress()."'", 'GroupId' => 1, 'Photo' => 'NULL', 'Gender' => $isgen, 'MobileNumber' => 'NULL', 'RelationshipId' => 3, 'Location' => 'NULL', 'Religion' => 'NULL');
				$result = $this->model->NewUser($data);
				if($result>0){
					$mess = 'Dear, '.$user_profile['email'].' !!<br><br>You are loged to '.$this->model->cfsite['SiteName'].' via Facebook account.<br>This is your password: '.$str.'<br><br>Best regards !';
					@mail(trim($user_profile['email']), '=?UTF-8?B?'.base64_encode('Active account '.$this->model->cfsite['SiteName']).'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".$this->model->cfsite['AdminEmail']);
					$_SESSION['uid'] = $result;
					$_SESSION['umail'] = $user_profile['email'];
					$_SESSION['ugrou'] = 1;
					header('Location: '.BASE_URL.'?member&account');
					return;
					}
				else{
					$_SESSION['error'] = 'Can not login via Facebook account';
					header('Location: '.BASE_URL.'?member&signin');
					return;
					}
				}
			}
		}
	public function TwloginAction(){
		require_once 'twitteroauth.php';
		$CONSUMER_KEY='zdGxxBWL26bs1BiqY5CO1bp9D';
		$CONSUMER_SECRET='arSiyHxAvFdhTDh3KNL8sO9vsJdo3GmHxfweJKLPyMHugQMT1E';
		$OAUTH_CALLBACK=BASE_URL.'?index&Twlogin';
		if(isset($_GET['oauth_token'])){
			$connection = new TwitterOAuth($CONSUMER_KEY, $CONSUMER_SECRET, $_SESSION['request_token'], $_SESSION['request_token_secret']);
			$access_token = $connection->getAccessToken($_REQUEST['oauth_verifier']);
			if($access_token){
				$connection = new TwitterOAuth($CONSUMER_KEY, $CONSUMER_SECRET, $access_token['oauth_token'], $access_token['oauth_token_secret']);
				$params =array();
				$params['include_entities']='false';
				$content = $connection->get('account/verify_credentials',$params);
				if($content && isset($content->screen_name) && isset($content->name)){
					print_r ($content);
					}
				}
			}
		else{
			$connection = new TwitterOAuth($CONSUMER_KEY, $CONSUMER_SECRET);
			$request_token = $connection->getRequestToken($OAUTH_CALLBACK);
			if(	$request_token){
				$token = $request_token['oauth_token'];
				$_SESSION['request_token'] = $token ;
				$_SESSION['request_token_secret'] = $request_token['oauth_token_secret'];	
				switch ($connection->http_code){
					case 200:
						$url = $connection->getAuthorizeURL($token);
						header('Location: ' . $url); 
						break;
					default:
						echo "Coonection with twitter Failed";
						break;
					}
				}
			}
		}
	public function YhloginAction(){
		require_once 'lib/openid.php';
		try {
			$openid = new LightOpenID('http://coryapp.com');
			if(!$openid->mode) {
				$openid->identity = 'https://me.yahoo.com';
				$openid->required = array('contact/email', 'birthDate/birthYear', 'phone/default');
				$openid->optional = array('namePerson/first', 'namePerson/friendly', 'namePerson/middle');
				header('Location: ' . $openid->authUrl());
				}
			elseif($openid->mode == 'cancel')
				header('Location: '.BASE_URL.'?member&signin');
			else{
				$arr_result = $openid->getAttributes();
				$exits = $this->model->UserExits($arr_result['contact/email']);
				if($exits[0]==-1){
					$_SESSION['error'] = 'An error occurred, please try again';
					header('Location: '.BASE_URL.'?member&signin');
					return;
					}
				elseif($exits[0]==-2){
					$_SESSION['error'] = 'Can not check banned for user';
					header('Location: '.BASE_URL.'?member&signin');
					return;
					}
				elseif($exits[0]==-3){
					$_SESSION['error'] = '<i>Your account has banned.<br>Reason: '.$exits[1].'<br>Banned date: '.$exits[2].'</i>';
					header('Location: '.BASE_URL.'?member&signin');
					return;
					}
				elseif($exits[0]>0){
					$_SESSION['uid'] = $exits[0];
					$_SESSION['umail'] = $arr_result['contact/email'];
					$_SESSION['ugrou'] = 1;
					header('Location: '.BASE_URL.'?member&account');
					return;
					}
				elseif($exits[0]==0){
					$str = $this->random_string(6);
					$random = sha1($this->random_string(32).$arr_result['contact/email'].$str);
					$data = array('Email' => "'".addslashes(trim($arr_result['contact/email']))."'", 'FullName' => "'".$arr_result['namePerson/friendly']."'", 'Birthday' => 'NULL', 'Password' => "'".md5($str.$str)."'", 'RandomStr' => "'".$str."'", 'StrActive' => "'".$random."'", 'IsActive' => 1, 'SignedDate' => "'".date('Y-m-d')."'", 'LastLogin' => "'".date('Y-m-d')."'", 'IpAddress' => "'".$this->IpAddress()."'", 'GroupId' => 1, 'Photo' => 'NULL', 'Gender' => 3, 'MobileNumber' => 'NULL', 'RelationshipId' => 3, 'Location' => 'NULL', 'Religion' => 'NULL');
					$result = $this->model->NewUser($data);
					if($result>0){
						$mess = 'Dear, '.$arr_result['contact/email'].' !!<br><br>You are loged to '.$this->model->cfsite['SiteName'].' via Yahoo account.<br>This is your password: '.$str.'<br><br>Best regards !';
						@mail(trim($arr_result['contact/email']), '=?UTF-8?B?'.base64_encode('Active account '.$this->model->cfsite['SiteName']).'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".$this->model->cfsite['AdminEmail']);
						$_SESSION['uid'] = $result;
						$_SESSION['umail'] = $arr_result['contact/email'];
						$_SESSION['ugrou'] = 1;
						header('Location: '.BASE_URL.'?member&account');
						return;
						}
					else{
						$_SESSION['error'] = 'Can not login via Yahoo account';
						header('Location: '.BASE_URL.'?member&signin');
						return;
						}
					}
				}
			}
		catch(ErrorException $e){
			echo $e->getMessage();
			}
		}
	public function GmailloginAction(){
		require_once 'lib/openid.php';
		try {
			$openid = new LightOpenID('http://coryapp.com');
			if(!$openid->mode) {
				$openid->identity = 'https://www.google.com/accounts/o8/id';
				$openid->required = array('contact/email', 'birthDate/birthYear', 'phone/default', 'postaladdressadditional/home', 'namePerson/first', 'namePerson/friendly', 'namePerson/middle');
        		$openid->optional = array('namePerson/first', 'namePerson/friendly', 'namePerson/middle');
				header('Location: ' . $openid->authUrl());
				}
			elseif($openid->mode == 'cancel')
				header('Location: '.BASE_URL.'?member&signin');
			else{
				$arr_result = $openid->getAttributes();
				$exits = $this->model->UserExits($arr_result['contact/email']);
				if($exits[0]==-1){
					$_SESSION['error'] = 'An error occurred, please try again';
					header('Location: '.BASE_URL.'?member&signin');
					return;
					}
				elseif($exits[0]==-2){
					$_SESSION['error'] = 'Can not check banned for user';
					header('Location: '.BASE_URL.'?member&signin');
					return;
					}
				elseif($exits[0]==-3){
					$_SESSION['error'] = '<i>Your account has banned.<br>Reason: '.$exits[1].'<br>Banned date: '.$exits[2].'</i>';
					header('Location: '.BASE_URL.'?member&signin');
					return;
					}
				elseif($exits[0]>0){
					$_SESSION['uid'] = $exits[0];
					$_SESSION['umail'] = $arr_result['contact/email'];
					$_SESSION['ugrou'] = 1;
					header('Location: '.BASE_URL.'?member&account');
					return;
					}
				elseif($exits[0]==0){
					$str = $this->random_string(6);
					$random = sha1($this->random_string(32).$arr_result['contact/email'].$str);
					$data = array('Email' => "'".addslashes(trim($arr_result['contact/email']))."'", 'FullName' => "'".$arr_result['namePerson/first']."'", 'Birthday' => 'NULL', 'Password' => "'".md5($str.$str)."'", 'RandomStr' => "'".$str."'", 'StrActive' => "'".$random."'", 'IsActive' => 1, 'SignedDate' => "'".date('Y-m-d')."'", 'LastLogin' => "'".date('Y-m-d')."'", 'IpAddress' => "'".$this->IpAddress()."'", 'GroupId' => 1, 'Photo' => 'NULL', 'Gender' => 3, 'MobileNumber' => 'NULL', 'RelationshipId' => 3, 'Location' => 'NULL', 'Religion' => 'NULL');
					$result = $this->model->NewUser($data);
					if($result>0){
						$mess = 'Dear, '.$arr_result['contact/email'].' !!<br><br>You are loged to '.$this->model->cfsite['SiteName'].' via Gmail account.<br>This is your password: '.$str.'<br><br>Best regards !';
						@mail(trim($arr_result['contact/email']), '=?UTF-8?B?'.base64_encode('Active account '.$this->model->cfsite['SiteName']).'?=', $mess, "Content-Type: text/html; charset=utf-8\r\nFrom: ".$this->model->cfsite['AdminEmail']);
						$_SESSION['uid'] = $result;
						$_SESSION['umail'] = $arr_result['contact/email'];
						$_SESSION['ugrou'] = 1;
						header('Location: '.BASE_URL.'?member&account');
						return;
						}
					else{
						$_SESSION['error'] = 'Can not login via Gmail account';
						header('Location: '.BASE_URL.'?member&signin');
						return;
						}
					}
				}
			}
		catch(ErrorException $e){
			echo $e->getMessage();
			}
		}
	}